/***************************************************************
	CPUoX
***************************************************************/

/* CPUŗLWX^`wb_ */
#include "iodefine.h"

/* CPU/荞ݐ֐wb_ */
#include "cpu_init.h"

volatile int IntCount;				// LED_Ń[N

static int CMT_Interval = 1;		// ^C}荞ݎ(2.5msec~)
static int CMT_TmDivCnt = 0;		// ^C}[荞ݕ
static int CMT_Count = 0;

/*============================================================================*/
/*!	\brief		CPU_BusInitialize()
	\param		Ȃ
	\retval		Ȃ
	\note		CPUŗL
*//*==========================================================================*/
void CPU_BusInitialize()
{
	/*--- FRQCRݒ NbN I:B:P = 144MHz:48MHz:24MHz ---*/
	CPG.FRQCR.WORD  = 0x1104;
}

/*============================================================================*/
/*!	\brief		CPU_IRQ3Initialize()
	\param		Ȃ
	\retval		Ȃ
	\note		CPU荞ݏ
	\warring	W5100I/F{[hڑĂȂԂł̊֐Ă΂ȂłB
				IRQ3̐MɉqĂȂƊ荞݂|ɂȂ邩
*//*==========================================================================*/
void CPU_IRQ3Initialize(void)
{
	/* O荞ݓ͗L */
	PORT.PECR0.BIT.PE3MD = 3; /* PE3[q̋@\ = IRQ3 */

	/* 荞ݓ͐Mݒ(1:GbW) */
	INTC.ICR1.BIT.IRQ31S = 0;
	INTC.ICR1.BIT.IRQ30S = 1;
}

/*============================================================================*/
/*!	\brief		CPU_IRQ3Enable()
	\param		Ȃ
	\retval		Ȃ
	\note		IRQ3荞݋
*//*==========================================================================*/
void CPU_IRQ3Enable()
{
	/* 荞݃xݒ(0:Œ 15:ō) */
	INTC.IPR01.BIT._IRQ3 = 15;
	
	/* GbW荞ݐݒ莞 */
	INTC.IRQRR.BIT.IRQ3F = 0;	/* IRQ3荞݃NA */
}

/*============================================================================*/
/*!	\brief		CPU_IRQ3Disable()
	\param		Ȃ
	\retval		Ȃ
	\note		IRQ3荞݋֎~
*//*==========================================================================*/
void CPU_IRQ3Disable()
{
	/* 荞݃xݒ(0:Œ 15:ō) */
	INTC.IPR01.BIT._IRQ3 = 0;
}

/*============================================================================*/
/*!	\brief		LED_Initialize()
	\param		Ȃ
	\retval		Ȃ
	\note		CPULED_䏉
*//*==========================================================================*/
void LED_Initialize(void)
{
	/*--- PCDR0 ݒ PC8 LED ---*/
	PORT.PCDR0.BIT.PC8DR = 1;
	
	/*--- PCIOR0 ݒ PC8 LEDo͂ɐݒ	---*/
	PORT.PCIOR0.WORD |= 0x0100u;
	
	/*--- PCCR2 ݒ PC8 ̐ݒ ---*/
	PORT.PCCR2.WORD &= 0xFFF0;
}

/*============================================================================*/
/*!	\brief		void LED_Ctrl(int i)
	\param		i	0:OFF / 1:ON
	\retval		Ȃ
	\note		CPULED_
*//*==========================================================================*/
void LED_Ctrl(int i)
{
	PORT.PCDR0.BIT.PC8DR = (i ? 0 : 1); /* PC8='L'(_):'H'() */
}

/*============================================================================*/
/*!	\brief		void LED_Interrupt()
	\param		Ȃ
	\retval		Ȃ
	\note		LED荞ݏ
*//*==========================================================================*/
void LED_Interrupt()
{
	IntCount += CMT_Interval;
	if (IntCount >= 40) {
		LED_Ctrl(0);	/*  */
	}
	if (IntCount >= 280) {
		LED_Ctrl(1);	/* _ */
		IntCount=0;
	}
}

/*============================================================================*/
/*!	\brief		CMT0_Initialize()
	\param		Ȃ
	\retval		Ȃ
	\note		RyA}b`^C}0 
*//*==========================================================================*/
void CMT0_Initialize(void)
{
	IntCount = 0;

	/*--- STBCR7ݒ CMTNbNJn ---*/
	CPG.STBCR7.BIT.MSTP72 = 0;

	/* RyA}b`^C}0 荞݃x15 */
	INTC.IPR10.BIT._CMT0 = 14;

	/*--- CMSTRݒ CMCNT0JEg~ ---*/
	CMT.CMSTR.BIT.STR0 = 0;
	
	/*--- CMCNT0ݒ 0NA ---*/
	CMT.CMCNT0.WORD = 0x0000;
	
	/*--- CMCSR0ݒ CMI NbNݒ[P/32] ---*/
	CMT.CMCSR0.WORD = 0x0041;
	
	/*--- CMCOR0ݒ ---*/
	CMT.CMCOR0.WORD = 1874;		// _Ŏ(2.5ms)
	CMT_TmDivCnt = 0;
	CMT_Count = 0;
	
	/*--- CMSTRݒ CMCNT0JEgJn	---*/
	CMT.CMSTR.BIT.STR0 = 0x1;

	/* CPULED_䏉 */
	LED_Initialize();
	/* CPULED_ */
	LED_Ctrl(1);	/* _ */
}

/*============================================================================*/
/*!	\brief		CMT0_TimerSet(int n)
	\param		n		_Ŏ(2.5ms~n{)	
	\retval		Ȃ
	\note		RyA}b`^C}0 Đݒ
*//*==========================================================================*/
void CMT0_TimerSet(int n)
{
	int	count;

	if (n<=0) n=1;

	/*--- CMSTRݒ CMCNT0JEg~ ---*/
	CMT.CMSTR.BIT.STR0 = 0;
	
	/*--- CMCNT0ݒ 0NA ---*/
	CMT.CMCNT0.WORD = 0x0000;
	
	/*--- CMCOR0ݒ ---*/
	count = 1874*n;			// ^C}荞ݎ(2.5ms~n{)
	if(count >= 0x10000)	// 16rbgJE^I[o[t[
	{
		CMT_TmDivCnt = (count >> 16) + 1;
		count /= CMT_TmDivCnt;		// JEgl
	}
	else
	{
		CMT_TmDivCnt = 0;
	}
	CMT_Count = 0;
	CMT_Interval = n;
	CMT.CMCOR0.WORD = count;
	
	/*--- CMSTRݒ CMCNT0JEgJn	---*/
	CMT.CMSTR.BIT.STR0 = 0x1;
}

/*============================================================================*/
/*!	\brief		CMT0_Interrupt()
	\param		Ȃ
	\retval		Ȃ
	\note		RyA}b`^C}0 荞ݏ
*//*==========================================================================*/
void CMT0_Interrupt(void)
{
	/*--- CMF 0NA ---*/
	CMT.CMCSR0.BIT.CMF = 0;

	if( ++CMT_Count > CMT_TmDivCnt )
	{
		CMT_Count = 0;

		LED_Interrupt();			// LED荞ݏ
	}
}

