/*============================================================================*/
/*!	\file		netUty.c
	\brief		lbg[N [eBeB	
	\author		kuni
	\date		2010/07/31
	\version	1.01
//*==========================================================================*/
#include "netUty.h"


static word swapw( us_t );
static dword swapl( ul_t );

/*============================================================================*/
/*!	\brief		word swapw( us_t data )
	\param		Ȃ
	\retval		Ȃ
	\note		16bitf[^̃oCgPʂ̓ւ
*//*==========================================================================*/
static word swapw( us_t data )
{
	us_t	ret;

	ret.bytes.lo = data.bytes.hi;
	ret.bytes.hi = data.bytes.lo;
	return	ret.data;
}
/*============================================================================*/
/*!	\brief		dword swapl( ul_t data )
	\param		Ȃ
	\retval		Ȃ
	\note		32bitf[^̃oCgPʂ̓ւ
*//*==========================================================================*/
static dword swapl( ul_t data )
{
	ul_t	ret;

	ret.bytes.ll = data.bytes.hh;
	ret.bytes.lh = data.bytes.hl;
	ret.bytes.hl = data.bytes.lh;
	ret.bytes.hh = data.bytes.ll;
	return	ret.data;
}
/*============================================================================*/
/*!	\brief		dword mkAddr( int d0, int d1, int d2, int d3 )
	\param		Ȃ
	\retval		Ȃ
	\note		R[hϊ
*//*==========================================================================*/
dword mkAddr( int d0, int d1, int d2, int d3 )
{
	ul_t	t;

	t.bytes.hh = d0;
	t.bytes.hl = d1;
	t.bytes.lh = d2;
	t.bytes.ll = d3;

	return t.data;
}

/*============================================================================*/
/*!	\brief		word	htons( word data )
	\param		ւf[^
	\retval		ւ̃f[^
	\note		zXglbg[ÑoCgI[_ϊ(16bit)
*//*==========================================================================*/
word htons( word data )
{
#if (ENDIAN_TYPE == ENDIAN_LITTLE)
	return swapw( *(us_t*)(&data) );
#else
	return	data;
#endif
}


/*============================================================================*/
/*!	\brief		word	ntohs( word data )
	\param		ւf[^
	\retval		ւ̃f[^
	\note		lbg[NzXg̃oCgI[_ϊ(16bit)
*//*==========================================================================*/
word ntohs( word data )
{
#if (ENDIAN_TYPE == ENDIAN_LITTLE)
	return swapw( *(us_t*)(&data) );
#else
	return	data;
#endif
}


/*============================================================================*/
/*!	\brief		dword	htonl( dword data )
	\param		ւf[^
	\retval		ւ̃f[^
	\note		zXglbg[ÑoCgI[_ϊ(32bit)
*//*==========================================================================*/
dword htonl( dword data )
{
#if (ENDIAN_TYPE == ENDIAN_LITTLE)
	return swapl( *(ul_t*)(&data) );
#else
	return	data;
#endif
}


/*============================================================================*/
/*!	\brief		dword	ntohl( dword data )
	\param		ւf[^
	\retval		ւ̃f[^
	\note		lbg[NzXg̃oCgI[_ϊ(32bit)
*//*==========================================================================*/
dword	ntohl( dword data )
{
#if (ENDIAN_TYPE == ENDIAN_LITTLE)
	return swapl( *(ul_t*)(&data) );
#else
	return	data;
#endif
}


/*============================================================================*/
/*!	\brief		char *inet_ntoa( dword ip, char *buf )
	\param		ip:hoAhX
				buf:i[敶
	\retval		obt@|C^
	\note		lbg[NAhXhbgtWɕϊ
*//*==========================================================================*/
char	*inet_ntoa( dword ip, char *buf )
{
	ul_t	tmp;
	char	*p;

	tmp.data = ip;
	p = btodec( tmp.bytes.hh, buf );
	*p++ = '.';
	p = btodec( tmp.bytes.hl, p );
	*p++ = '.';
	p = btodec( tmp.bytes.lh, p );
	*p++ = '.';
	p = btodec( tmp.bytes.ll, p );

	return	buf;
}

/*============================================================================*/
/*!	\brief		char *btodec( byte data, char *pBuf)
	\param		byte data	o͒l
				char *pBuf	i[obt@|C^
	\retval		̏I_ʒu
	\note		oCgl10iɕϊ
*//*==========================================================================*/
char *btodec( byte data, char *pBuf )
{
	byte n;

	if( data >= 100 )	*pBuf++ = data/100+'0';
	n = data%100;
	if( data >= 10 )    *pBuf++ = n/10+'0';
	*pBuf++ = n%10+'0';
	*pBuf = '\0';
	return pBuf;
}

