/*============================================================================*/
/*!	\file		sci2.c
	\brief		SH7262 VAR\[o̓hCo
	\author		kuni
	\date		2010/08/02
	\version	1.0
*//*==========================================================================*/

#include "iodefine.h"
#include "sci2.h"

#define	MAXRXBUF	256		/* Mobt@TCY	*/
#define	MAXTXBUF	256		/* Mobt@TCY	*/

volatile unsigned char *rxp, *rxbp, rxbuf[MAXRXBUF];	// VAM[N
volatile unsigned char *txp, *txbp, txbuf[MAXTXBUF];	// VAM[N

/*============================================================================*/
/*!	\brief		void SCI2_Initialize()
	\param		unsigned char data
	\retval		Ȃ
	\note		R\[(UART)
*//*==========================================================================*/
void SCI2_Initialize(void)
{
	unsigned short int sts;

	rxp = rxbp = rxbuf;				/* VAM[NNA */
	txp = txbp = txbuf;				/* VAM[NNA */

	/* SCIF2X^oC */
	CPG.STBCR4.BIT.MSTP45 = 0;		/* SCIF2ւ̃NbNJn	*/

	/* SCIFxݒ */
	SCIF2.SCSCR.WORD    = 0x0000;	/* M~    TE=0,RE=0,CKE1=0 */
	SCIF2.SCFCR.WORD    = 0x0006;	/* MFIFZbg TFRST=1,RFRST=1 */
	sts = SCIF2.SCFSR.WORD;			/* MXe[^Xǂ */
	SCIF2.SCFSR.WORD   &= 0xff6eu;	/* ERADRABRK rbgNA */
	SCIF2.SCLSR.WORD   &= 0x0000;	/* ORER rbgNA */
	SCIF2.SCSMR.WORD    = 0x0000;	/* VAʐMtH[}bg CHR=0,PE=0,STOP=0,CKS=00(P/1) */
	SCIF2.SCSCR.BIT.CKE = 0x00;		/* NbN\[X̑I CKE[1:0]rbgݒ */
	SCIF2.SCEMR.WORD    = 0x0080;	/* ʐMx̐ݒ 115.2kbps	*/
	SCIF2.SCBRR.BYTE    = 12;		/* ݒ */
	SCIF2.SCFCR.WORD    = 0x0000;	/* FIFORg[ TREG:8bytes RTRG:1bytes */

	/* @\[qݒ */
	PORT.PFCR0.BIT.PF2MD = 4;		/* PF2=RxD2 */
	PORT.PFCR0.BIT.PF1MD = 4;		/* PF1=TxD2 */

	SCIF2.SCSCR.WORD = 0x0070;		/* TIE=0,RIE=1,TE=1,RE=1, RIE=0 */

	/* SCIF2M荞݃x15 */
	INTC.IPR17.BIT._SCIF2 = 15;
}

/*============================================================================*/
/*!	\brief		void SCI2_Putch(unsigned char data)
	\param		unsigned char data
	\retval		Ȃ
	\note		R\[1o
*//*==========================================================================*/
void SCI2_Putch(unsigned char data)
{
	if(SCIF2.SCSCR.BIT.TIE)		// M荞ݏ
	{
		// Oobt@Fullp|C^
		unsigned char *txnp = (txp >= &txbuf[MAXTXBUF-2]) ? txbuf : txp+1;

		while( txnp == txbp );		// Mobt@FullȂ҂
		
		*txp = data;				// Oobt@փZbg
		txp = txnp;
	}
	else
	{
	    while( SCIF2.SCFDR.BIT.T >= 15 );	// MFIFO f[^GveB
	    SCIF2.SCFTDR.BYTE = data;			/* Mf[^ */
		SCIF2.SCFSR.BIT.TDFE = 0;			/* Xe[^XNA	*/
		SCIF2.SCSCR.BIT.TIE = 1;			/* M荞݋	*/
	}
}

/*============================================================================*/
/*!	\brief		void SCI2_PutLf()
	\param		Ȃ
	\retval		Ȃ
	\note		R\[ CR+LFo
*//*==========================================================================*/
void SCI2_PutLf()
{
	SCI2_Putch('\r');	/* CRo */
	SCI2_Putch('\n');	/* LFo */
}

/*============================================================================*/
/*!	\brief		void SCI2_Puts(char *buffer)
	\param		char *buffer
	\retval		Ȃ
	\note		R\[o(\n CR+LFo)
*//*==========================================================================*/
void SCI2_Puts( char *buffer)
{
	while( *buffer != 0)		/* null܂ŏo */
	{
		if (*buffer == '\n')
		{
			buffer ++;
			SCI2_PutLf();				/* CR+LFo */
		} else {
			SCI2_Putch( *(buffer ++) );	/* 1o */
		}
	}
}

/*============================================================================*/
/*!	\brief		void SCI2_PutsL(char *buffer, int len)
	\param		char *buffer
	\param		int len
	\retval		Ȃ
	\note		R\[o(񒷂wt/\n CR+LFo)
*//*==========================================================================*/
void SCI2_PutsL(char *buffer, int len)
{
	int i;

	for(i=0; i<len; i++)
	{
		if (*buffer == '\n')
		{
			buffer ++;
			SCI2_PutLf();				/* CR+LFo */
		} else {
			SCI2_Putch( *(buffer ++) );	/* 1o */
		}
	}
}

/*============================================================================*/
/*!	\brief		int SCI2_RecvCheck(void)
	\param		Ȃ
	\retval		0:Mf[^ / 0ȊO:Mf[^L
	\note		Mf[^`FbN
*//*==========================================================================*/
int SCI2_RecvCheck(void)
{
	return (rxp != rxbp);
}

/*============================================================================*/
/*!	\brief		void SCI2_BRInt(void)
	\param		Ȃ
	\retval		Ȃ
	\note		u[N(BRK)܂̓I[o(ORER)ɂ銄荞ݏiBRIj
*//*==========================================================================*/
void SCI2_BRInt(void)
{
	/* ==== u[NMoAI[oG[̊mF ==== */
	if((SCIF2.SCFSR.BIT.BRK == 1) || (SCIF2.SCLSR.BIT.ORER == 1))
	{
		SCIF2.SCSCR.BIT.RE = 0;			/* M֎~ */
		SCIF2.SCFCR.BIT.RFRST = 1;		/* MFIFO Zbg */
		SCIF2.SCFCR.BIT.RFRST = 0;		/* MFIFO Zbg */
		SCIF2.SCFSR.WORD &= ~0x0011u; 	/* BRK,DR rbgNA */

		SCIF2.SCLSR.BIT.ORER = 0;		/* ORER rbg̃NA */
		SCIF2.SCFSR.BIT.RDF = 0;		/* RDF rbgNA */
		SCIF2.SCSCR.BIT.RE = 1;			/* M */
	}
}

/*============================================================================*/
/*!	\brief		void SCI2_ERInt(void)
	\param		Ȃ
	\retval		Ȃ
	\note		MG[(ER)ɂ銄荞ݏiERIj
*//*==========================================================================*/
void SCI2_ERInt(void)
{
	volatile unsigned short dummy;
	/* ==== MG[̊mF ==== */
	if(SCIF2.SCFSR.BIT.ER == 1)
	{
		SCIF2.SCFSR.BIT.ER = 0;		 	/* ERrbgNA */
		dummy = SCIF2.SCLSR.WORD; 		/* 荞ݗvmɃNA邽߂̃_~[[h */
	}
}

/*============================================================================*/
/*!	\brief		void SCI2_RXInt(void)
	\param		Ȃ
	\retval		Ȃ
	\note		M荞ݏ
*//*==========================================================================*/
void SCI2_RXInt(void)
{
	while( SCIF2.SCFDR.BIT.R )			/* MoCg`FbN	*/
	{
		*rxp = SCIF2.SCFRDR.BYTE;		/* Mf[^ǂݍ */
		if( ++rxp >= &rxbuf[MAXRXBUF-1] )
		{
			rxp = rxbuf;
		}
	}
	SCIF2.SCFSR.WORD &= 0xfffc;			/* RDF:MFIFO Data Full,DR:MData Ready NA */
}

/*============================================================================*/
/*!	\brief		void SCI2_TXInt(void)
	\param		Ȃ
	\retval		Ȃ
	\note		M荞ݏ
*//*==========================================================================*/
void SCI2_TXInt(void)
{
	if( txp != txbp )						/* Mf[^L */
	{
		do {
			SCIF2.SCFTDR.BYTE = *txbp;		/* Mf[^ */
			if( ++txbp >= &txbuf[MAXTXBUF-1] )
			{
				txbp = txbuf;
			}
			if( txp == txbp )	break;		/* Mf[^I	*/
		} while(SCIF2.SCFDR.BIT.T < 15);

		SCIF2.SCFSR.BIT.TDFE = 0;			/* Xe[^XNA	*/
	}
	else
	{
		SCIF2.SCSCR.BIT.TIE = 0;			/* M荞݋֎~	*/
	}
}

/*============================================================================*/
/*!	\brief		byte SCI2_Getch(void)
	\param		Ȃ
	\retval		͕
	\note		R\[1(GR[obNȂ)
*//*==========================================================================*/
byte SCI2_Getch(void)
{
	unsigned char data;

	while(!SCI2_RecvCheck());		/* f[^M҂ */

	data = *rxbp;
	if( ++rxbp >= &rxbuf[MAXRXBUF-1] )
	{
		rxbp = rxbuf;
	}
	return data;
}

/*============================================================================*/
/*!	\brief		int SCI2_Gets( char *buffer)
	\param		char *buffer	̓obt@
	\retval		Ȃ
	\note		R\[(CRR[h܂/ő255/GR[obN)
*//*==========================================================================*/
int SCI2_Gets( char *buffer)
{
	int i;

	for( i=0; i<255; i++ )
	{
		SCI2_Putch( (*buffer ++ = SCI2_Getch()) );	/* 1(GR[obN) */

		if (*buffer == '\r')				/* CRR[hM */
		{
			i ++;
			break;							/* I */
		}
	}
	*buffer = '\0';							/* nullR[h */
	return i;								/* ͕ */
}

/*============================================================================*/
/*!	\brief		void SCI2_PutBin( byte data )
	\param		byte data	o͒li4bitj
	\retval		Ȃ
	\note		BinlASCIIŏo
*//*==========================================================================*/
void SCI2_PutBin( byte data )
{
	data &= 0x0f;
	SCI2_Putch( data + (( data < 10 ) ? '0': 'A' - 10) );
}

/*============================================================================*/
/*!	\brief		void SCI2_PutByte( byte data )
	\param		byte data	oCgo͒li8bitj
	\retval		Ȃ
	\note		oCglASCIIo
*//*==========================================================================*/
void SCI2_PutByte( byte data )
{
    SCI2_PutBin( (data >> 4) );
    SCI2_PutBin( data );
}

/*============================================================================*/
/*!	\brief		void SCI2_PutWord( word data )
	\param		word data	[ho͒li16bitj
	\retval		Ȃ
	\note		[hlASCIIo
*//*==========================================================================*/
void SCI2_PutWord( word data )
{
    SCI2_PutBin( (data >> 12) );
    SCI2_PutBin( (data >> 8) );
    SCI2_PutBin( (data >> 4) );
    SCI2_PutBin( data );
}

/*============================================================================*/
/*!	\brief		void SCI2_PutLong( lword data )
	\param		lword data	Oo͒li32bitj
	\retval		Ȃ
	\note		OlASCIIo
*//*==========================================================================*/
void SCI2_PutLong( lword data )
{
    SCI2_PutBin( (data >> 28) );
    SCI2_PutBin( (data >> 24) );
    SCI2_PutBin( (data >> 20) );
    SCI2_PutBin( (data >> 16) );
    SCI2_PutBin( (data >> 12) );
    SCI2_PutBin( (data >> 8) );
    SCI2_PutBin( (data >> 4) );
    SCI2_PutBin( data );
}
/*============================================================================*/
/*!	\brief		void SCI2_PutDec( byte data )
	\param		byte data	o͒l
	\retval		Ȃ
	\note		oCgl10io
*//*==========================================================================*/
void SCI2_PutDec( byte data )
{
	byte n;

	if( data >= 100 )	SCI2_Putch( data/100+'0' );
	n = data%100;
	if( data >= 10 )    SCI2_Putch( n/10+'0' );
	SCI2_Putch( n%10+'0' );
}
/*============================================================================*/
/*!	\brief		void SCI2_PutDecW( word data )
	\param		word data	o͒l
	\retval		Ȃ
	\note		oCgl10io
*//*==========================================================================*/
void SCI2_PutDecW( word data )
{
	word n;

	if( data >= 10000 )	SCI2_Putch( data/10000+'0' );
	n = data%10000;
	if( data >= 1000 ) SCI2_Putch( n/1000+'0' );
	n = data%1000;
	if( data >= 100 ) SCI2_Putch( n/100+'0' );
	n = data%100;
	if( data >= 10 ) SCI2_Putch( n/10+'0' );
	SCI2_Putch( n%10+'0' );
}
/*============================================================================*/
/*!	\brief		void SCI2_PutDecl( dword data )
	\param		dword data	o͒l
	\retval		Ȃ
	\note		oCgl10io
*//*==========================================================================*/
void SCI2_PutDecl( dword data )
{
	dword n;

	if( data >= 100000000L ) SCI2_Putch( data/100000000L+'0' );
	n = data%100000000L;
	if( data >= 10000000L ) SCI2_Putch( data/10000000L+'0' );
	n = data%10000000L;
	if( data >= 1000000L ) SCI2_Putch( data/1000000L+'0' );
	n = data%1000000L;
	if( data >= 100000L ) SCI2_Putch( data/100000L+'0' );
	n = data%100000L;
	if( data >= 10000 ) SCI2_Putch( data/10000+'0' );
	n = data%10000;
	if( data >= 1000 ) SCI2_Putch( n/1000+'0' );
	n = data%1000;
	if( data >= 100 ) SCI2_Putch( n/100+'0' );
	n = data%100;
	if( data >= 10 ) SCI2_Putch( n/10+'0' );
	SCI2_Putch( n%10+'0' );
}
