/*============================================================================*/
/*!	\file		socket.c
	\brief		\Pbg֐Q
	\author		kuni
	\date		2010/07/31
	\version	1.01
*//*==========================================================================*/
#include	<string.h>
#include	"socket.h"

static word	local_port = 0x5000;

#define	WAIT_ENDPROCESS(sn)	while(getSnCR(sn))		// R}hF܂ő҂



extern info_t	socksts[MAX_SOCKET];	/* e\Pbg */


/*============================================================================*/
/*!	\brief		SOCKET	socket( SOCKET sn, byte protocol, word port, byte opt )
	\param		SOCKET sn		\Pbgԍ(0-3)
	\param		byte protocol	gpvgR(SOCK_STREAM/SOCK_DGRAM/SOCK_RAW/SOCK_RDM/SOCK_PPPoE)
	\param		word port		gp|[gԍ(SOCK_RAW̓vgRԍ)
								0Ń|[gԍ(NCAg\Pbg̏ꍇ)
	\param		byte opt		\PbgIvV
								NO_OPTION		Ȃ
								NO_DELAY_ACK	No Delayed Ackw (TCP̂)
								MULTICAST		}`LXgw (UDP̂)
								MULTICAST_V1	}`LXgw (UDP̂) using IGMP version 1
	\retval		0ȏ:(\Pbgԍ) INVALID_SOCKET:s
	\note		w肵vgR̃\Pbg𐶐
	\warring	MAC RAW, PPPoE ̓\Pbg0ł̂ݎw\
*//*==========================================================================*/
SOCKET	socket( SOCKET sn, byte protocol, word port, byte opt )
{
	SOCKET	ret;
	const	byte sr[] = { 0, Sn_SR_INIT, Sn_SR_UDP, Sn_SR_IPRAW, Sn_SR_MACRAW, Sn_SR_PPPoE };

	if (( protocol >= SOCK_STREAM ) && ( protocol <= SOCK_PPPoE ))
	{
		closesocket( sn );						/* xN[Y */

		setSnMR((char)sn, protocol | opt );		/* vgRݒ */
		switch(protocol)
		{
		case SOCK_STREAM:	/* TCP */
		case SOCK_DGRAM:	/* UDP */
			setSnSrcPort((char)sn, ((port != 0) ? port : local_port++) );	/* |[gݒ */
			break;
		
		case SOCK_RAW:		/* IPRAW */
			setSnProto((char)sn, (byte)port );	/* vgRݒ */
			break;
		}
		setSnCR((char)sn, Sn_CR_OPEN );			/* \Pbg */

		WAIT_ENDPROCESS((char)sn );				/* I҂ */
		ret = (getSnSR( (char)sn ) == sr[protocol]) ? (int)sn : INVALID_SOCKET;
	}
	else	/* vgRw肪ԈĂ */
	{
		ret = INVALID_SOCKET;
	}

	return	ret;
}


/*============================================================================*/
/*!	\brief		int	closesocket( SOCKET sn )
	\param		SOCKET sn	\Pbgԍ
	\retval		0:  SOCKET_ERROR:s
	\note		\PbgN[Y()
*//*==========================================================================*/
int	closesocket( SOCKET sn )
{
	setSnCR( sn, Sn_CR_CLOSE );	/* \PbgN[Y	*/

	WAIT_ENDPROCESS( sn );	/* I҂ */

	return	(getSnSR( sn ) == Sn_SR_CLOSED) ? 0 : SOCKET_ERROR;
}


/*============================================================================*/
/*!	\brief		int	listen( SOCKET sn )
	\param		SOCKET sn	\Pbgԍ
	\retval		0: SOCKET_ERROR:s
	\note		LISTENԂɂ(TCPT[o)
*//*==========================================================================*/
int	listen( SOCKET sn )
{
	bool	ret;

	if( getSnSR( sn ) == Sn_SR_INIT )	/* INITXe[gł */
	{
		setSnCR( sn, Sn_CR_LISTEN );	/* LISTENݒ	*/
		WAIT_ENDPROCESS( sn );			/* I҂ */
		ret = (getSnSR( sn ) == Sn_SR_LISTEN) ? 0 : SOCKET_ERROR;	/* s */
	}
	else
	{
		ret = SOCKET_ERROR;
	}

	return	ret;
}


/*============================================================================*/
/*!	\brief		int	connect( SOCKET sn, dword addr, word port )
	\param		SOCKET sn	\Pbgԍ
	\param		dword addr	T[oIPAhX
	\param		word port	T[õ|[gԍ
	\retval		0:  SOCKET_ERROR:s
	\note		TCPT[oɐڑ(TCPNCAg)
*//*==========================================================================*/
int	connect( SOCKET sn, dword addr, word port )
{
	bool	ret;

	if(( addr == 0xffffffff ) || ( addr == 0 ) || ( port == 0x00 ))
	{
 		ret = SOCKET_ERROR;
	}
	else
	{
		setSnDestIp((char)sn, addr );		/* IPAhX */
		setSnDestPort((char)sn, port );		/* ̃|[g */
		setSnCR((char)sn, Sn_CR_CONNECT );	/* ڑR}h */
		WAIT_ENDPROCESS((char)sn );			/* I҂ */
		ret = (getSnSR( sn ) == Sn_SR_ESTABLISHED) ? 0 : SOCKET_ERROR;	/* ڑm	*/
	}

	return	ret;
}


/*============================================================================*/
/*!	\brief		int	disconnect( SOCKET sn )
	\param		SOCKET sn	\Pbgԍ
	\retval		0:  SOCKET_ERROR:s
	\note		RlNV̐ؒf(TCP)
*//*==========================================================================*/
int	disconnect( SOCKET sn )
{
	int	ret;

	setSnCR((char)sn, Sn_CR_DISCON );	/* ؒfR}h	*/

	WAIT_ENDPROCESS((char)sn );			/* I҂ */
	return (getSnSR((char)sn ) == Sn_SR_CLOSED) ? 0 : SOCKET_ERROR;	/* ԈڂmF */
}


/*============================================================================*/
/*!	\brief		int	send( SOCKET sn, byte *buf, int len )
	\param		SOCKET sn	\Pbgԍ
	\param		byte *buf	Mf[^obt@
	\param		int len		MTCY
	\retval		SOCKET_ERROR:s  ȊO:Mf[^TCY
	\note		TCPf[^M
	\warring	Mobt@TCY𒴂ꍇ̓obt@TCY܂ł̑MƂȂ
*//*==========================================================================*/
int	send( SOCKET sn, byte *buf, int len )
{
	byte	stat;
	int	ret, free, max;

	ret = 0;
	max = socksts[sn].TxSize;
	ret = (len > max) ? max : len;

	do{	/* Mobt@󂭂̂҂ */
		free = getSnTxFsr((char)sn );
		stat = getSnSR((char)sn );
		if(( stat != Sn_SR_ESTABLISHED ) && ( stat != Sn_SR_CLOSE_WAIT ))
		{
			return	SOCKET_ERROR;
		}
	} while( free < ret );

	send_data((char)sn, buf, ret );	/* f[^Rs[ */
	setSnCR((char)sn, Sn_CR_SEND );	/* MR}h */

	WAIT_ENDPROCESS((char)sn );		/* I҂ */

	while( !( getSnIR((char)sn ) & Sn_IR_SEND_OK ) )	/* MOK҂ */
	{
		if( getSnSR((char)sn ) == Sn_SR_CLOSED )
		{
			closesocket( sn );
			return	SOCKET_ERROR;
		}
  	}
	setSnIR((char)sn, Sn_IR_SEND_OK );	/* tONA */

	return	ret;
}


/*============================================================================*/
/*!	\brief		int	recv( SOCKET sn, byte *buf, int max_len )
	\param		SOCKET sn	\Pbgԍ
	\param		byte *buf	f[^i[obt@
	\param		int max_len	őMTCY
	\retval		SOCKET_ERROR:s  ȊO:MTCY
	\note		TCPf[^M
	\warning	max_len ȏ̃f[^󂯎ꍇÂ͎Ă܂B
*//*==========================================================================*/
int	recv( SOCKET sn, byte *buf, int max_len )
{
	int	data_len, ret;

	data_len = getSnRxRsr((char)sn );	/* Mf[^TCY */
	if( data_len > 0 )
	{
		word	rxPtr;
		int		rec_len = ((data_len > max_len) ? max_len : data_len);
		
		rxPtr = getSnRxRd( sn );			/* Mǂݏo|C^ */
		read_data( sn, rxPtr, buf, rec_len );	/* f[^ǂݏo */
		rxPtr += data_len;
		setSnRxRd( sn, rxPtr );			/* Mǂݏo|C^XV */
		
		setSnCR((char)sn, Sn_CR_RECV );	/* Mʒm */

		WAIT_ENDPROCESS((char)sn );		/* I҂ */
		ret = rec_len;
	}
	else
	{
		ret = SOCKET_ERROR;
	}

	return	ret;
}


/*============================================================================*/
/*!	\brief		int	sendto( SOCKET sn, byte *buf, int len, dword addr, word port )
	\param		SOCKET sn	\Pbgԍ
	\param		byte *buf	f[^obt@
	\param		int len		f[^
	\param		dword addr	IPAhX
	\param		word port	̃|[gԍ
	\retval		SOCKET_ERROR:s  ȊO:Mf[^TCY
	\note		f[^M(UDP,IP_RAW,MAC_RAW[h)
	\warring	Mobt@TCY𒴂ꍇ̓obt@TCY܂ł̑MƂȂ
*//*==========================================================================*/
int	sendto( SOCKET sn, byte *buf, int len, dword addr, word port )
{
	int	ret, max;
	byte	ir;

	max = socksts[sn].TxSize;
	ret = ( len > max ) ? max : len;

	if(( addr == 0 ) || ( port == 0x00 ) || ( ret == 0 ))	/* sp[^ */
	{
		ret = SOCKET_ERROR;
	}
	else
	{
		setSnDestIp((char)sn, addr );		/* IPAhX */
		setSnDestPort((char)sn, port );		/* ̃|[g */

		send_data((char)sn, buf, ret );		/* obt@Ƀf[^ */
		setSnCR((char)sn, Sn_CR_SEND );		/* MR}h */

		WAIT_ENDPROCESS( (char)sn );		/* I҂ */
		while( 1 )
		{
			ir = getSnIR( (char)sn );
			if( ir & Sn_IR_SEND_OK )		/* M */
			{
				setSnIR((char)sn, Sn_IR_SEND_OK );
				break;
			}
			else if( ir & Sn_IR_TIMEOUT )	/* ^CAEg */
			{
				setSnIR((char)sn, Sn_IR_SEND_OK | Sn_IR_TIMEOUT );
				ret = SOCKET_ERROR;
				break;
			}
		}
	}

	return	ret;
}


/*============================================================================*/
/*!	\brief		int	recvfrom( SOCKET sn, byte *buf, int max_len, dword *addr, word *port )
	\param		sn		\Pbgԍ
	\param		buf		f[^i[obt@
	\param		max_len	őMf[^TCY
	\param		addr	MIPAhXi[(MACRAWNULLw)
	\param		port	M|[gԍi[(IPRAW,MACRAWNULLw)
	\retval		SOCKET_ERROR:s  ȊO:M
	\note		f[^M(UDP,IP_RAW,MAC_RAW[h)
	\warning	max_len ȏ̃f[^󂯎ꍇÂ͎Ă܂B
*//*==========================================================================*/
int	recvfrom( SOCKET sn, byte *buf, int max_len, dword *addr, word *port )
{
	word	rxPtr;
	int		data_len, ret;
	int		rec_len;

	data_len = 0;
	rxPtr = getSnRxRd( sn );	/* Mǂݏo|C^ */
	switch( getSnSR( sn ) )		/* vgR */
	{
	case Sn_SR_UDP:		/* UDPM */
		{
			struct{	/* UDP\ */
				dword	addr;	/* MIPAhX */
				word	port;	/* M|[g */
				word	length;	/*  */
			} head;
			
			read_data( sn, rxPtr, (byte *)&head, sizeof(head) );	/* wb_ǂݍ */
			rxPtr += sizeof(head);
			if(addr != NULL)	*addr = ntohl( head.addr );
			if(port != NULL)	*port = ntohs( head.port );
			data_len = ntohs( head.length );
			rec_len = ((data_len > max_len) ? max_len : data_len);
			
			read_data( sn, rxPtr, buf, rec_len );	/* f[^ǂݏo */
			rxPtr += data_len;
			setSnRxRd( sn, rxPtr );	/* Mǂݏo|C^XV */
			ret = rec_len;
		}
		break;

	case Sn_SR_IPRAW:	/* IPRAW */
		{
			struct{	/* IPRAW\ */
				dword	addr;	/* MIPAhX */
				word	length;	/*  */
			} head;

			read_data( sn, rxPtr, (byte *)&head, sizeof(head) );/* wb_ǂݍ */
			rxPtr += sizeof(head);
			if(addr != NULL)	*addr = ntohl( head.addr );
			data_len = ntohs( head.length );
			rec_len = ((data_len > max_len) ? max_len : data_len);
			
			read_data( sn, rxPtr, buf, rec_len );
			rxPtr += data_len;
			setSnRxRd( sn, rxPtr );	/* Mǂݏo|C^XV */
			ret = rec_len;
		}
		break;

	case Sn_SR_MACRAW:		/* MACRAW */
		{
			word	length;	/*  */

			read_data( sn, rxPtr, (byte*)&length, sizeof(word) );
			rxPtr += sizeof(word);
			data_len = ntohs( length );
			rec_len = ((data_len > max_len) ? max_len : data_len);
			
			read_data( sn, rxPtr, buf, rec_len );
			rxPtr += data_len;
			setSnRxRd( sn, rxPtr );	/* Mǂݏo|C^XV */
			ret = rec_len;
		}
		break;

	default:
		ret = SOCKET_ERROR;
		break;
	}
	setSnCR( sn, Sn_CR_RECV );	/* Mʒm */

	WAIT_ENDPROCESS( sn );

 	return	ret;
}


/* end of socket.c */
