/*============================================================================*/
/*!	\file		socket.
	\brief		\PbgQ	wb_
	\author		kuni
	\date		2010/07/31
	\version	1.01
*//*==========================================================================*/
#ifndef	_SOCKET_DEFINED_
#define	_SOCKET_DEFINED_

#include	"w5100.h"
#include	"netUty.h"

#define	SOCKET		int	/* \Pbg` */
#define	INVALID_SOCKET  (SOCKET)(~0)	/*  */
#define	SOCKET_ERROR            (-1)

/* \Pbgԍ` */
#define	SOCKET0		0
#define	SOCKET1		1
#define	SOCKET2		2
#define	SOCKET3		3

/* gpvgR(Sn_MR P3`P0) */
#define	SOCK_STREAM		Sn_MR_TCP		/* TCP	*/
#define	SOCK_DGRAM		Sn_MR_UDP		/* UDP	*/
#define	SOCK_RAW		Sn_MR_IPRAW		/* IP RAW	*/
#define	SOCK_RDM		Sn_MR_MACRAW	/* MAC RAW (SOCK0̂)	*/
#define	SOCK_PPPoE		Sn_MR_PPPoE		/* PPPoE   (SOCK0̂)	*/

/* IvVtO(Sn_MR) */
#define	NO_OPTION		0x00
#define	NO_DELAY_ACK	Sn_MR_ND				/* No Delayed Ackw (TCP̂) */
#define	MULTICAST		Sn_MR_MULTI				/* }`LXgw (UDP̂) */
#define	MULTICAST_V1	(Sn_MR_MULTI|Sn_MR_MC)	/* }`LXgw (UDP̂) using IGMP version 1 */

/* vgRԍ */
#define	IPPROTO_IP		0		/* IP   # Protocol internet */
#define	IPPROTO_ICMP	1		/* ICMP # Protocol internet pour messages de controle */
#define	IPPROTO_IGMP	2		/* IGMP # Protocol internet pour multi-cast */
#define	IPPROTO_GGP		3		/* GGP  # Protocol internet passerelle/passerelle */
#define	IPPROTO_TCP		6		/* TCP  # Protocol internet de controle de transmisson */
#define	IPPROTO_PUP		12		/* PUP  # Protocol internet universel PARC */
#define	IPPROTO_UDP		17		/* UDP  # Protocol internet pour Datagrammes */
#define	IPPROTO_RAW		255		/* RAW  # Interface IP directe. */

/* vg^Cv */
extern SOCKET	socket( SOCKET sn, byte protocol, word port, byte opt );	/* \Pbg(I[v) */
extern int	closesocket( SOCKET sn );						/* \PbgN[Y */
extern int	listen( SOCKET sn );							/* LISTEN (TCPT[o) */
extern int	connect( SOCKET sn, dword addr, word port );	/* T[oւ̐ڑ (TCPNCAg) */
extern int	disconnect( SOCKET sn );						/* RlNV̐ؒf(TCP) */

extern int	send( SOCKET sn, byte *buf, int len );			/* f[^M(TCP)	*/
extern int	recv( SOCKET sn, byte *buf, int len );			/* f[^M(TCP)	*/
extern int	sendto( SOCKET sn, byte *buf, int len, dword addr, word port );		/* f[^M(UDP,IP RAW,MAC RAW)	*/
extern int	recvfrom( SOCKET sn, byte *buf, int len, dword *addr, word *port );	/* f[^M(UDP,IP RAW,MAC RAW)	*/

#endif	// _SOCKET_DEFINED_
