/*============================================================================*/
/*!	\file		w5100.c
	\brief		W5100hCo	
	\author		kuni
	\date		2010/07/31
	\version	1.01
*//*==========================================================================*/
#include	"w5100.h"

#define	SockReg(n,r)	(sn_base[n]+r)	// \PbgWX^AhX

static void	initSockMem( byte tx_size, byte rx_size );	/* \Pbg[N	*/


info_t	socksts[MAX_SOCKET];	/* e\Pbg */

/* ---------- \PbgWX^ x[XAhXz ---------- */
static const word	sn_base[] = { S0_BASE, S1_BASE, S2_BASE, S3_BASE };


/* -------------------- RWX^ -------------------- */

/*============================================================================*/
/*!	\brief		void	clrNetInterrupt( byte mask )
	\param		mask	NAv
	\retval		Ȃ
	\note		荞ݗvNA
*//*==========================================================================*/
void	clrNetInterrupt( byte mask )
{
	w5100_write( W5100_IR, mask );	// clear 
}
/*============================================================================*/
/*!	\brief		byte	getNetInterrupt( void )
	\param		Ȃ
	\retval		荞ݗv
	\note		荞ݗv擾
*//*==========================================================================*/
byte	getNetInterrupt( void )
{
	return	w5100_read( W5100_IR );
}
/*============================================================================*/
/*!	\brief		void	setNetIntMask( byte mask )
	\param		mask	荞݃}XN
	\retval		Ȃ
	\note		荞݃}XNݒ
	mask bit
	IR_CONFLICT			IPAhXՓ
	IR_UNREACH			UDPMɂsB
	IR_PPPoE			PPPoEN[Y
	IR_SOCK(ch)			\Pbg荞(0-3)
*//*==========================================================================*/
void	setNetIntMask( byte mask )
{
	w5100_write( W5100_IMR, mask );	// enabel 
}
/*============================================================================*/
/*!	\brief		byte	getNetIntMask( void )
	\param		Ȃ
	\retval		荞݃}XN
	\note		荞݃}XN擾
*//*==========================================================================*/
byte	getNetIntMask( void )
{
	return	w5100_read( W5100_IMR );
}
/*============================================================================*/
/*!	\brief		void	setRetryTime( word timeout )
	\param		đ܂ł̎
	\retval		Ȃ
	\note		đԐݒ
*//*==========================================================================*/
void	setRetryTime( word timeout )
{
	us_t	t;

	t.data = timeout;
	w5100_write( W5100_RTR0, t.bytes.hi );
	w5100_write( W5100_RTR1, t.bytes.lo );
}


/*============================================================================*/
/*!	\brief		word	getRetryTime( void )
	\param		Ȃ
	\retval		ݒ肳Ăđ܂ł̎
	\note		đԎ擾
*//*==========================================================================*/
word	getRetryTime( void )
{
	us_t	t;

	t.bytes.hi = w5100_read( W5100_RTR0 );
	t.bytes.lo = w5100_read( W5100_RTR1 );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setRetryCnt( byte retry )
	\param		đ
	\retval		Ȃ
	\note		đ񐔐ݒ
*//*==========================================================================*/
void	setRetryCnt( byte retry )
{
	w5100_write( W5100_RCR, retry );
}


/*============================================================================*/
/*!	\brief		byte	getRetryCnt( void )
	\param		Ȃ
	\retval		đ
	\note		đ񐔎擾
*//*==========================================================================*/
byte	getRetryCnt( void )
{
	return	w5100_read( W5100_RCR );
}


/*============================================================================*/
/*!	\brief		void	setSrcIp( dword addr )
	\param		IPAhX
	\retval		Ȃ
	\note		\[XIPAhXݒ
*//*==========================================================================*/
void	setSrcIp( dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( W5100_SIPR0, t.bytes.hh );
	w5100_write( W5100_SIPR1, t.bytes.hl );
	w5100_write( W5100_SIPR2, t.bytes.lh );
	w5100_write( W5100_SIPR3, t.bytes.ll );
}


/*============================================================================*/
/*!	\brief		dword	getSrcIp( void )
	\param		Ȃ
	\retval		IPAhX
	\note		\[XIPAhX擾
*//*==========================================================================*/
dword	getSrcIp( void )
{
	ul_t	t;

	t.bytes.hh = w5100_read( W5100_SIPR0 );
	t.bytes.hl = w5100_read( W5100_SIPR1 );
	t.bytes.lh = w5100_read( W5100_SIPR2 );
	t.bytes.ll = w5100_read( W5100_SIPR3 );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setNetmask( dword addr )
	\param		lbg}XNl
	\retval		߂l
	\note		Tulbg}XNݒ
*//*==========================================================================*/
void	setNetmask( dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( W5100_SUBR0, t.bytes.hh );
	w5100_write( W5100_SUBR1, t.bytes.hl );
	w5100_write( W5100_SUBR2, t.bytes.lh );
	w5100_write( W5100_SUBR3, t.bytes.ll );
}

/*============================================================================*/
/*!	\brief		dword	getNetmask( void )
	\param		Ȃ
	\retval		lbg}XN
	\note		Tulbg}XN擾
*//*==========================================================================*/
dword	getNetmask( void )
{
	ul_t	t;

	t.bytes.hh = w5100_read( W5100_SUBR0 );
	t.bytes.hl = w5100_read( W5100_SUBR1 );
	t.bytes.lh = w5100_read( W5100_SUBR2 );
	t.bytes.ll = w5100_read( W5100_SUBR3 );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setGateway( dword addr )
	\param		Q[gEFCAhX
	\retval		Ȃ
	\note		Q[gEFCAhXݒ
*//*==========================================================================*/
void	setGateway( dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( W5100_GAR0, t.bytes.hh );
	w5100_write( W5100_GAR1, t.bytes.hl );
	w5100_write( W5100_GAR2, t.bytes.lh );
	w5100_write( W5100_GAR3, t.bytes.ll );
}


/*============================================================================*/
/*!	\brief		dword	getGateway( void )
	\param		Ȃ
	\retval		Q[gEFCAhX
	\note		Q[gEFCAhX擾
*//*==========================================================================*/
dword	getGateway( void )
{
	ul_t	t;

	t.bytes.hh = w5100_read( W5100_GAR0 );
	t.bytes.hl = w5100_read( W5100_GAR1 );
	t.bytes.lh = w5100_read( W5100_GAR2 );
	t.bytes.ll = w5100_read( W5100_GAR3 );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setMacAddr( byte *addr )
	\param		MACAhXobt@
	\retval		Ȃ
	\note		\[XMACAhXݒ
*//*==========================================================================*/
void	setMacAddr( byte *addr )
{
	w5100_writebuf( W5100_SHAR0, addr, 6 );
}


/*============================================================================*/
/*!	\brief		void	getMacAddr( byte *addr )
	\param		i[obt@
	\retval		Ȃ
	\note		\[XMACAhX擾
*//*==========================================================================*/
void	getMacAddr( byte *addr )
{
	w5100_readbuf( W5100_SHAR0, addr, 6 );
}


/*============================================================================*/
/*!	\brief		word	getPatr( void )
	\param		Ȃ
	\retval		PPPoE[h̔F؃^Cv
	\note		PPPoE[h̔F؃^Cv擾
*//*==========================================================================*/
word	getPatr( void )
{
	us_t	t;

	t.bytes.hi = w5100_read( W5100_PATR0 );
	t.bytes.lo = w5100_read( W5100_PATR1 );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		dword	getUIp( void )
	\param		Ȃ
	\retval		񓞒BIPAhX
	\note		񓞒BIPAhX擾
*//*==========================================================================*/
dword	getUIp( void )
{
	ul_t	t;

	t.bytes.hh = w5100_read( W5100_UIPR0 );
	t.bytes.hl = w5100_read( W5100_UIPR1 );
	t.bytes.lh = w5100_read( W5100_UIPR2 );
	t.bytes.ll = w5100_read( W5100_UIPR3 );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		word	getUPort( void )
	\param		Ȃ
	\retval		񓞒B|[gԍ
	\note		񓞒B|[gԍ擾
*//*==========================================================================*/
word	getUPort( void )
{
	us_t	t;

	t.bytes.hi = w5100_read( W5100_UPORT0 );
	t.bytes.lo = w5100_read( W5100_UPORT1 );

	return	t.data;
}


/* -------------------- \Pbgʑ ---------------------- */


/*============================================================================*/
/*!	\brief		void	setSnMR( char sn, byte val )
	\param		char sn:\Pbgԍ
	\param		byte val: MRݒl
	\retval		Ȃ
	\note		\Pbg̃vgRIvV̐ݒs
*//*==========================================================================*/
void	setSnMR( char sn, byte val )
{
	w5100_write( SockReg(sn,Sn_MR), val );
}


/*============================================================================*/
/*!	\brief		byte	getSnMR( char sn )
	\param		\Pbgԍ
	\retval		[hl
	\note		\Pbg̃[hݒl擾
*//*==========================================================================*/
byte	getSnMR( char sn )
{
	return	w5100_read( SockReg(sn,Sn_MR) );;
}


/*============================================================================*/
/*!	\brief		void	setSnCR( char sn, byte command )
	\param		 sn: \Pbgԍ
	\param		command: R}hSn_CR_XXXX
	\retval		Ȃ
	\note		\Pbgɑ΂R}h(Open,Close,Connect,Send,Recv)ݒ肷
*//*==========================================================================*/
void	setSnCR( char sn, byte command )
{
	w5100_write( SockReg(sn,Sn_CR), command );
}


/*============================================================================*/
/*!	\brief		byte	getSnCR( char sn )
	\param		\Pbgԍ
	\retval		R}hWX^l
	\note		\Pbgɑ΂R}h̏Ԃ擾
				R}hFƎ0ɃNA
				0ɂȂĂR}hs̉\
				R}h̊Sn_IR,Sn_SRʂĊmF
*//*==========================================================================*/
byte	getSnCR( char sn )
{
	return	w5100_read( SockReg(sn,Sn_CR) );
}


/*============================================================================*/
/*!	\brief		void	setSnIR( char sn, byte val )
	\param		sn	\Pbgԍ
	\param		val	NAvrbgSn_IR_XXXX
	\retval		Ȃ
	\note		\Pbg̊荞ݗvNA
*//*==========================================================================*/
void	setSnIR( char sn, byte val )
{
	w5100_write( SockReg(sn,Sn_IR), val );
}


/*============================================================================*/
/*!	\brief		byte	getSnIR( char sn )
	\param		\Pbgԍ
	\retval		荞ݗv	Sn_IR_XXXX
	\note		\Pbg̊荞ݗv擾
*//*==========================================================================*/
byte	getSnIR( char sn )
{
	return w5100_read( SockReg(sn,Sn_IR) );
}


/*============================================================================*/
/*!	\brief		byte	getSnSR( char sn )
	\param		\Pbgԍ
	\retval		Xe[^X
	\note		\PbgԎ擾
*//*==========================================================================*/
byte	getSnSR( char sn )
{
	return w5100_read( SockReg(sn,Sn_SR) );
}


/*============================================================================*/
/*!	\brief		void	setSnSrcPort( char sn, word port )
	\param		sn: \Pbgԍ
	\param		addr: |[gԍ
	\retval		Ȃ
	\note		\Pbg M|[gݒ
*//*==========================================================================*/
void	setSnSrcPort( char sn, word port )
{
	us_t	t;

	t.data = port;
	w5100_write( SockReg(sn,Sn_PORT0), t.bytes.hi );
	w5100_write( SockReg(sn,Sn_PORT1), t.bytes.lo );
}


/*============================================================================*/
/*!	\brief		word	getSnSrcPort( char sn )
	\param		\Pbgԍ
	\retval		|[gԍ
	\note		\Pbg M|[g擾
*//*==========================================================================*/
word	getSnSrcPort( char sn )
{
	us_t	t;

	t.bytes.hi = w5100_read( SockReg(sn,Sn_PORT0) );
	t.bytes.lo = w5100_read( SockReg(sn,Sn_PORT1) );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setSnDestMac( char sn, byte *addr )
	\param		 sn: \Pbgԍ
	\param		addr: MACAhX
	\retval		Ȃ
	\note		\Pbg̑MMACAhXݒ
*//*==========================================================================*/
void	setSnDestMac( char sn, byte *addr )
{
	w5100_writebuf( SockReg(sn,Sn_DHAR0), addr, 6 );
}


/*============================================================================*/
/*!	\brief		void	getSnDestMac( char sn, byte *addr )
	\param		sn: \Pbgԍ
	\param		addr: MACAhXi[
	\retval		Ȃ
	\note		\Pbg MMACAhX擾
*//*==========================================================================*/
void	getSnDestMac( char sn, byte *addr )
{
	w5100_readbuf( SockReg(sn,Sn_DHAR0), addr, 6 );
}


/*============================================================================*/
/*!	\brief		void	setSnDestIp( char sn, dword addr )
	\param		sn: \Pbgԍ
	\param		addr: IPAhX
	\retval		Ȃ
	\note		\Pbg MIPAhXݒ
*//*==========================================================================*/
void	setSnDestIp( char sn, dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( SockReg(sn,Sn_DIPR0), t.bytes.hh );
	w5100_write( SockReg(sn,Sn_DIPR1), t.bytes.hl );
	w5100_write( SockReg(sn,Sn_DIPR2), t.bytes.lh );
	w5100_write( SockReg(sn,Sn_DIPR3), t.bytes.ll );
}


/*============================================================================*/
/*!	\brief		dword	getSnDestIp( char sn )
	\param		\Pbgԍ
	\retval		IPAhX
	\note		\Pbg MIPAhX擾
*//*==========================================================================*/
dword	getSnDestIp( char sn )
{
	ul_t	t;

	t.bytes.hh = w5100_read( SockReg(sn,Sn_DIPR0) );
	t.bytes.hl = w5100_read( SockReg(sn,Sn_DIPR1) );
	t.bytes.lh = w5100_read( SockReg(sn,Sn_DIPR2) );
	t.bytes.ll = w5100_read( SockReg(sn,Sn_DIPR3) );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setSnDestPort( char sn, word port )
	\param		sn: \Pbgԍ
	\param		addr: |[gԍ
	\retval		Ȃ
	\note		\Pbg M|[gݒ
*//*==========================================================================*/
void	setSnDestPort( char sn, word port )
{
	us_t	t;

	t.data = port;
	w5100_write( SockReg(sn,Sn_DPORT0), t.bytes.hi );
	w5100_write( SockReg(sn,Sn_DPORT1), t.bytes.lo );
}


/*============================================================================*/
/*!	\brief		word	getSnDestPort( char sn )
	\param		\Pbgԍ
	\retval		|[gԍ
	\note		\Pbg M|[g擾
*//*==========================================================================*/
word	getSnDestPort( char sn )
{
	us_t	t;

	t.bytes.hi = w5100_read( SockReg(sn,Sn_DPORT0) );
	t.bytes.lo = w5100_read( SockReg(sn,Sn_DPORT1) );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setSnMSS( char sn, word mss )
	\param		\Pbgԍ
	\retval		MSSl
	\note		\Pbg MSSݒ
*//*==========================================================================*/
void	setSnMSS( char sn, word mss )
{
	us_t	t;

	t.data = mss;
	w5100_write( SockReg(sn,Sn_MSSR0), t.bytes.hi );
	w5100_write( SockReg(sn,Sn_MSSR1), t.bytes.lo );
}


/*============================================================================*/
/*!	\brief		word	getSnMSS( char sn )
	\param		\Pbgԍ
	\retval		MSSl
	\note		\Pbg MSS擾
*//*==========================================================================*/
word	getSnMSS( char sn )
{
	us_t	t;

	t.bytes.hi = w5100_read( SockReg(sn,Sn_MSSR0) );
	t.bytes.lo = w5100_read( SockReg(sn,Sn_MSSR1) );

	return	t.data;
}


/*============================================================================*/
/*!	\brief		void	setSnTOS( char sn, byte val )
	\param		\Pbgԍ
	\param		TOSl
	\retval		Ȃ
	\note		\Pbg TOS(Type Of servise)ݒ
*//*==========================================================================*/
void	setSnTOS( char sn, byte val )
{
	w5100_write( SockReg(sn,Sn_TOS), val );
}


/*============================================================================*/
/*!	\brief		byte	getSnTOS( char sn )
	\param		\Pbgԍ
	\retval		TOSl
	\note		\Pbg TOS(Type Of servise)擾
*//*==========================================================================*/
byte	getSnTOS( char sn )
{
	return	w5100_read( SockReg(sn,Sn_TOS) );
}


/*============================================================================*/
/*!	\brief		void	setSnTTL( char sn, byte val )
	\param		\Pbgԍ
	\param		TTLl
	\retval		Ȃ
	\note		\Pbg TTL(Time to live)ݒ
*//*==========================================================================*/
void	setSnTTL( char sn, byte val )
{
	w5100_write( SockReg(sn,Sn_TTL), val );
}


/*============================================================================*/
/*!	\brief		byte	getSnTTL( char sn )
	\param		\Pbgԍ
	\retval		TTLl
	\note		\Pbg TTL擾
*//*==========================================================================*/
byte	getSnTTL( char sn )
{
	return	w5100_read( SockReg(sn,Sn_TTL) );
}


/*============================================================================*/
/*!	\brief		void	setSnProto( char sn, byte proto )
	\param		sn: \Pbgԍ
	\param		proto: vgRԍ
	\retval		Ȃ
	\note		IPwb_̃vgRԍZbg(IP RAW[h)
*//*==========================================================================*/
void	setSnProto( char sn, byte proto )
{
	w5100_write( SockReg(sn,Sn_PROTO), proto );
}


/*============================================================================*/
/*!	\brief		byte	getSnProto( char sn )
	\param		\Pbgԍ
	\retval		vgRԍ
	\note		IPwb_̃vgRԍ擾(IP RAW[h)
*//*==========================================================================*/
byte	getSnProto( char sn )
{
	return	w5100_read( SockReg(sn,Sn_PROTO) );
}


/*============================================================================*/
/*!	\brief		word	getSnTxFsr( char sn )
	\param		\Pbgԍ
	\retval		TCY
	\note		\Pbg̑Mobt@̋󂫃TCY擾
*//*==========================================================================*/
word	getSnTxFsr( char sn )
{
	us_t	val, val1;
	word	fsr;

	fsr = SockReg(sn,Sn_TX_FSR0);
	val.bytes.hi = w5100_read( fsr );
	val.bytes.lo = w5100_read( fsr+1 );

	do{	/* ǂłrōXV̂ */
		val1.data = val.data;
		val.bytes.hi = w5100_read( fsr );
		val.bytes.lo = w5100_read( fsr+1 );
	} while( val.data != val1.data );

	return	val.data;
}


/*============================================================================*/
/*!	\brief		word	getSnTxRd( char sn )
	\param		\Pbgԍ
	\retval		Mǂݎ|C^
	\note		\Pbg̑Mς݃f[^|C^擾
*//*==========================================================================*/
word	getSnTxRd( char sn )
{
	us_t	val;

	val.bytes.hi = w5100_read( SockReg(sn,Sn_TX_RD0) );
	val.bytes.lo = w5100_read( SockReg(sn,Sn_TX_RD1) );

	return	val.data;
}

/*============================================================================*/
/*!	\brief		void	setSnTxWr( char sn, word data )
	\param		\Pbgԍ
	\retval		Ȃ
	\note		\Pbg̑Mf[^݃|C^ݒ
*//*==========================================================================*/
void	setSnTxWr( char sn, word data )
{
	us_t	val;

	val.data = data;
	w5100_write( SockReg(sn,Sn_TX_WR0), val.bytes.hi );
	w5100_write( SockReg(sn,Sn_TX_WR1), val.bytes.lo );
}


/*============================================================================*/
/*!	\brief		word	getSnTxWr( char sn )
	\param		\Pbgԍ
	\retval		TCY
	\note		\Pbg̑Mf[^݂|C^擾
*//*==========================================================================*/
word	getSnTxWr( char sn )
{
	us_t	val;

	val.bytes.hi = w5100_read( SockReg(sn,Sn_TX_WR0) );
	val.bytes.lo = w5100_read( SockReg(sn,Sn_TX_WR1) );

	return	val.data;
}


/*============================================================================*/
/*!	\brief		word	getSnRxRsr( char sn )
	\param		\Pbgԍ
	\retval		TCY
	\note		\Pbg̎Mς݃f[^TCY擾
*//*==========================================================================*/
word	getSnRxRsr( char sn )
{
	us_t	val, val1;
	word	rsr;

	rsr = SockReg(sn,Sn_RX_RSR0);
	val.bytes.hi = w5100_read( rsr );
	val.bytes.lo = w5100_read( rsr+1 );

	do{	/* ǂłrōXV̂ */
		val1.data = val.data;
		val.bytes.hi = w5100_read( rsr );
		val.bytes.lo = w5100_read( rsr+1 );
	} while( val.data != val1.data );

	return	val.data;
}


/*============================================================================*/
/*!	\brief		void	setSnRxRd( char sn, word pnt )
	\param		sn	\Pbgԍ
	\param		pnt	|C^
	\retval		Ȃ
	\note		\Pbg̎Mf[^ǂݏo|C^ݒ
*//*==========================================================================*/
void	setSnRxRd( char sn, word pnt )
{
	us_t	val;

	val.data = pnt;
	w5100_write( SockReg(sn,Sn_RX_RD0), val.bytes.hi );
	w5100_write( SockReg(sn,Sn_RX_RD1), val.bytes.lo );
}


/*============================================================================*/
/*!	\brief		word	getSnRxRd( char sn )
	\param		\Pbgԍ
	\retval		|C^
	\note		\Pbg̎Mf[^ǂݏo|C^擾
*//*==========================================================================*/
word	getSnRxRd( char sn )
{
	us_t	val;

	val.bytes.hi = w5100_read( SockReg(sn,Sn_RX_RD0) );
	val.bytes.lo = w5100_read( SockReg(sn,Sn_RX_RD1) );

	return	val.data;
}


/* ---------- M ---------- */


/*============================================================================*/
/*!	\brief		byte	*read_data( char sn, word rxAddr, byte *rdBuf, word len )
	\param		sn		\Pbgԍ
	\param		rxAddr	Rs[obt@AhX(W5100)
	\param		rdBuf	i[擪AhX
	\param		len		M
	\retval		i[obt@擪AhX
	\note		W5100̎Mobt@Mf[^o
*//*==========================================================================*/
byte	*read_data( char sn, word rxAddr, byte *rdBuf, word len )
{
	word	base, offset, max, addr;

	max  = socksts[sn].RxSize;			/* Mobt@TCY	*/
	base = socksts[sn].RxBase;			/* Mobt@̐擪AhX */
	offset = rxAddr & (max - 1);		/* AhXItZbgvZ */
	if( (offset + len) > max )			/* obt@TCY𒴂Ă */
	{
		word	usize = max - offset;							/* Mobt@Ō܂ł̃TCY	*/

		w5100_readbuf( (base + offset), rdBuf, usize );			/* Mobt@Ō܂œǂݏo */
		w5100_readbuf( base, (rdBuf + usize), (len - usize) );	/* Mobt@擪ǂݏo */
	}
	else
	{
		w5100_readbuf( (base + offset), rdBuf, len );			/* Mobt@ǂݏo	*/
	}
	return	rdBuf;
}


/*============================================================================*/
/*!	\brief		void	send_data( char sn, byte *txDat, word len )
	\param		sn		\Pbgԍ
	\param		txDat	Mf[^obt@
	\param		len		MTCY
	\retval		Ȃ
	\note		f[^𑗐M
*//*==========================================================================*/
void	send_data( char sn, byte *txDat, word len )
{
	word	txwr, base, offset, max;

	max  = socksts[sn].TxSize;							/* Mobt@TCY	*/
	base = socksts[sn].TxBase;							/* Mobt@̐擪AhX */
	offset = (txwr = getSnTxWr( sn )) & (max - 1);		/* AhXItZbgvZ */
	if( (offset + len) > max )							/* obt@TCY𒴂Ă */
	{
		word	usize = max - offset;							/* Mobt@Ō܂ł̃TCY	*/

		w5100_writebuf( (base + offset), txDat, usize );		/* Mobt@Ō܂ŏ	*/
		w5100_writebuf( base, (txDat + usize), (len - usize) );	/* Mobt@擪珑	*/
	} 
	else
	{
		w5100_writebuf( (base + offset), txDat, len );			/* Mobt@֏	*/
	}

	setSnTxWr( sn, (txwr + len) );						/* Mobt@݃|C^XV */
}


/* --------------------  ---------------------- */



/*============================================================================*/
/*!	\brief		resetNetwork()
	\param		Ȃ
	\retval		Ȃ
	\note		W5100 S/WZbg
*//*==========================================================================*/
void resetNetwork(void)
{
	w5100_write( W5100_MR, MR_RST );	/* S/WZbg */
	while( (w5100_read( W5100_MR ) & MR_RST) ) {	/* ZbgI܂ő҂	*/
	}
	initSockMem( 0x55, 0x55 );			/* Zbg RMSR=0x55 TMSR=0x55 */
}
/*============================================================================*/
/*!	\brief		void	InitNetConf( void )
	\param		byte 	*mac		MACAhX
	\param		dword 	ipaddr		IPAhX
	\param		dword 	netmask		Tulbg}XN
	\param		dword 	gateway		Q[gEFCAhX
	\retval		Ȃ
	\note		lbg[N\
*//*==========================================================================*/
void	InitNetConf( byte *mac, dword ipaddr, dword netmask, dword gateway )
{
	resetNetwork();				/* S/WZbg	*/

	setMacAddr( mac );			/* MACAhX */
	setSrcIp( ipaddr );			/* IPAhX	*/
	setNetmask( netmask );		/* lbg}XN	*/
	setGateway( gateway );		/* Q[gEFC	*/
}


/*============================================================================*/
/*!	\brief		void	InitSocket( byte tx_size, byte rx_size )
	\param		Mobt@TCY
	\param		Mobt@TCY
	\retval		Ȃ
	\note		\Pbg[N
				 bit 1-0 : \PbgOTCY
				 bit 3-2 : \PbgPTCY
				 bit 5-4 : \PbgQTCY
				 bit 7-6 : \PbgRTCY
				 00:1KByte, 01:2KBtye, 10:4KByte, 11:8KByte
	\warning	TCY̍v8K𒴂鎖͂ł܂B
*//*==========================================================================*/
void	InitSocket( byte tx_size, byte rx_size )
{
	w5100_write( W5100_TMSR, tx_size );	/* MTCYZbg */
	w5100_write( W5100_RMSR, rx_size );	/* MTCYZbg */
	initSockMem( tx_size, rx_size );
}
/*============================================================================*/
/*!	\brief		void	initSockMem( byte tx_size, byte rx_size )
	\param		Mobt@TCY
	\param		Mobt@TCY
	\retval		Ȃ
	\note		\Pbg[N
				 bit 1-0 : \PbgOTCY
				 bit 3-2 : \PbgPTCY
				 bit 5-4 : \PbgQTCY
				 bit 7-6 : \PbgRTCY
				 00:1KByte, 01:2KBtye, 10:4KByte, 11:8KByte
	\warning	TCY̍v8K𒴂鎖͂ł܂B
*//*==========================================================================*/
static void	initSockMem( byte tx_size, byte rx_size )
{
	word	i, txsum, rxsum, tsize, rsize;

	txsum = rxsum = 0;
	for( i = 0 ; i < MAX_SOCKET; i++ )	/* \Pbg̃Ǘ[N */
	{
		tsize = rsize = 0;
		if( txsum < 8192 )	/* v8KoCg𒴂ĂȂꍇ */
		{
			tsize = (1024U << (tx_size & 0x03));
			tx_size >>= 2;
		}
		socksts[i].TxBase = W5100_TXBUF + txsum;	/* Mx[XAhX */
		socksts[i].TxSize = tsize;
		txsum += tsize;

		if( rxsum < 8192 )	/* v8KoCg𒴂ĂȂꍇ */
		{
			rsize = (1024U << (rx_size & 0x03));
			rx_size >> 2;
		}
		socksts[i].RxBase = W5100_RXBUF + rxsum;	/* Mx[XAhX */
		socksts[i].RxSize = rsize;
		rxsum += rsize;
	}
}


/* end of w5100.c */
