/*============================================================================*/
/*!	\file		w5100.h
	\brief		W5100hCo	wb_
	\author		kuni
	\date		2010/07/31
	\version	1.01
*//*==========================================================================*/
#ifndef	_W5100_DEFINED_
#define	_W5100_DEFINED_

#include "spi.h"


/*============================================================================*/
/*!	\brief		\Pbg
*//*==========================================================================*/

struct	INFO_T{			/* \Pbg */
	word	TxBase;		/* Mobt@x[XAhX */
	word	TxSize;		/* Mobt@TCY */

	word	RxBase;		/* Mobt@x[XAhX */
	word	RxSize;		/* Mobt@TCY */
};
typedef	struct INFO_T	info_t;

#define	MAX_SOCKET		4	/* ő\Pbg */



/* ---------- W5100 ---------- */
#define	W5100_TXBUF		0x4000	/* Mobt@JnAhX */
#define	W5100_RXBUF		0x6000	/* Mobt@JnAhX */

/* ---------- RWX^ ---------- */
#define	W5100_MR  		0x0000	/* [hWX^ S/WZbgA샂[hݒ */
#define	W5100_GAR0		0x0001	/* Q[gEFCAhX */
#define	W5100_GAR1		0x0002
#define	W5100_GAR2		0x0003
#define	W5100_GAR3		0x0004
#define	W5100_SUBR0		0x0005	/* Tulbg}XN */
#define	W5100_SUBR1		0x0006
#define	W5100_SUBR2		0x0007
#define	W5100_SUBR3		0x0008
#define	W5100_SHAR0		0x0009	/* MACAhX */
#define	W5100_SHAR1		0x000A
#define	W5100_SHAR2		0x000B
#define	W5100_SHAR3		0x000C
#define	W5100_SHAR4		0x000D
#define	W5100_SHAR5		0x000E
#define	W5100_SIPR0		0x000F	/* IPAhX */
#define	W5100_SIPR1		0x0010
#define	W5100_SIPR2		0x0011
#define	W5100_SIPR3		0x0012

#define	W5100_IR  		0x0015	/* 荞݃WX^ */
#define	W5100_IMR 		0x0016	/* 荞݃}XNWX^ */
#define	W5100_RTR0		0x0017	/* f[^ē]ҋ@ 100sP Zbg=2000(200ms) */
#define	W5100_RTR1		0x0018
#define	W5100_RCR 		0x0019	/* f[^ē]񐔃WX^ */
#define	W5100_RMSR		0x001A	/* MTCYWX^ */
#define	W5100_TMSR		0x001B	/* MTCYWX^ */
#define	W5100_PATR0		0x001C	/* PPPoE[h̔F؃^Cv T|[g@(0xC023=PAP,0xC223=CHAR) */
#define	W5100_PATR1		0x001D
#define	W5100_PTIMER	0x0028	/* PPP LCP Request Timer 25msP Zbg=40(1000ms) */
#define	W5100_PMAGIC	0x0029	/* PPP LCP Magic number */

#define	W5100_UIPR0		0x002A	/* UDP 񓞒BIPAhX */
#define	W5100_UIPR1		0x002B
#define	W5100_UIPR2		0x002C
#define	W5100_UIPR3		0x002D
#define	W5100_UPORT0	0x002E	/* UDP 񓞒B|[gԍ */
#define	W5100_UPORT1	0x002F

/* ---------- \PbgWX^ ---------- */
#define	S0_BASE			0x0400
#define	S1_BASE			0x0500
#define	S2_BASE			0x0600
#define	S3_BASE			0x0700

#define	Sn_MR			0x0000	/* [R/W] [hWX^ */
#define	Sn_CR			0x0001	/* [R/W] R}hWX^ (Open,Close,Connect,Listen,Send,Recv)R}hݒ肷 */
#define	Sn_IR			0x0002	/* [R]   荞݃WX^ */
#define	Sn_SR			0x0003	/* [R]   Xe[^XWX^ */
#define	Sn_PORT0		0x0004	/* [R/W] |[g */
#define	Sn_PORT1		0x0005
#define	Sn_DHAR0		0x0006	/* [R/W] ʐMMACAhX */
#define	Sn_DHAR1		0x0007
#define	Sn_DHAR2		0x0008
#define	Sn_DHAR3		0x0009
#define	Sn_DHAR4		0x000A
#define	Sn_DHAR5		0x000B
#define	Sn_DIPR0		0x000C	/* [R/W] ʐM̂hoAhX */
#define	Sn_DIPR1		0x000D
#define	Sn_DIPR2		0x000E
#define	Sn_DIPR3		0x000F
#define	Sn_DPORT0		0x0010	/* [R/W] ʐM̃|[g */
#define	Sn_DPORT1		0x0011
#define	Sn_MSSR0		0x0012	/* [R/W] Maximum Segment Size(MSS) */
#define	Sn_MSSR1		0x0013
#define	Sn_PROTO		0x0014	/* [R/W] IP RAW[h̃vgRԍ */
#define	Sn_TOS			0x0015	/* [R/W] IPwb_TOSl(Type Of servise) */
#define	Sn_TTL			0x0016	/* [R/W] IPwb_TTLl(Time to live) */
#define	Sn_TX_FSR0		0x0020	/* [R]   M̋󂫃TCY */
#define	Sn_TX_FSR1		0x0021
#define	Sn_TX_RD0		0x0022	/* [R]   Mf[^ǂݍ݈ʒu */
#define	Sn_TX_RD1		0x0023
#define	Sn_TX_WR0		0x0024	/* [R/W] Mf[^݈ʒu */
#define	Sn_TX_WR1		0x0025
#define	Sn_RX_RSR0		0x0026	/* [R]   M̎Mf[^TCY */
#define	Sn_RX_RSR1		0x0027
#define	Sn_RX_RD0		0x0028	/* [R/W] Mf[^ǂݍ݈ʒu */
#define	Sn_RX_RD1		0x0029


/* [hWX^rbg */
#define	MR_RST				(1<<7)	/* Zbg'1'̎Zbg܂Bbit̓ZbgɎŃNA܂B */
#define	MR_PB				(1<<4)	/* pingubN[h (0:֎~ 1:) bit'1'ɐݒ肳ꍇping echo͍sȂ */
#define	MR_PPPOE			(1<<3)	/* PPPoE          (0:֎~ 1:) */
#define	MR_AI				(1<<1)	/* I[gCNg(indirect mode) */
#define	MR_IND				(1<<0)	/* C_CNg[h(0:֎~ 1:) */

/* IR/IMRWX^rbg(荞݁^荞݃}XN) */
#define	IR_CONFLICT			(1<<7)		/* IPAhXՓ */
#define	IR_UNREACH			(1<<6)		/* UDPMɂsB */
#define	IR_PPPoE			(1<<5)		/* PPPoEN[Y */
#define	IR_SOCK(ch)			(1<<(ch))	/* \Pbg荞 */

/* Sn_MRWX^(vgR) */
#define	Sn_MR_CLOSE			0x00	/* \PbgN[Y */
#define	Sn_MR_TCP			0x01	/* TCPgp */
#define	Sn_MR_UDP			0x02	/* UDPgp */
#define	Sn_MR_IPRAW			0x03	/* lbg[Nwx̒ʐM */
#define	Sn_MR_MACRAW		0x04	/* f[^Nwx */
#define	Sn_MR_PPPoE			0x05	/* PPPoE */

#define	Sn_MR_ND			(1<<5)	/* No Delayed Ack(0:֎~ 1:) TCP̏ꍇɗL f[^pPbg󂯎ꍇACKpPbgMA\̂'1' */
#define	Sn_MR_MC			(1<<5)	/* using IGMP version (0:Ver.2 / 1:Ver.1) }`LXg  UDP̏ꍇɗL	*/
#define	Sn_MR_MULTI			(1<<7)	/* }`LXg(0:֎~ 1:) UDP̏ꍇɗL */

/* Sn_CRWX^(R}h) */
#define	Sn_CR_OPEN			0x01	/* \Pbg̃I[v^ */
#define	Sn_CR_LISTEN		0x02	/* NCAg̐ڑ҂(TCP T[o[h) */
#define	Sn_CR_CONNECT		0x04	/* T[oւ̐ڑ(TCP NCAg[h) */
#define	Sn_CR_DISCON		0x08	/* T[o̐ؒf(TCP) */
#define	Sn_CR_CLOSE			0x10	/* \Pbg̃N[Y */
#define	Sn_CR_SEND			0x20	/* f[^M(M|C^XV) */
#define	Sn_CR_SEND_MAC		0x21	/* SENDƓAARPŉMACAhXtŃf[^M(UDP,IPRAW) */
#define	Sn_CR_SEND_KEEP		0x22	/* L[vACubZ[WM(TCP) */
#define	Sn_CR_RECV			0x40	/* f[^M(M|C^XV) */

/* Sn_IRWX^i荞ݗvj */
#define	Sn_IR_SEND_OK		(1<<4)	/* M */
#define	Sn_IR_TIMEOUT		(1<<3)	/* ^CAEg */
#define	Sn_IR_RECV			(1<<2)	/* f[^M */
#define	Sn_IR_DISCON		(1<<1)	/* RlNVN[Y */
#define	Sn_IR_CON			(1<<0)	/* RlNVm */

/* Sn_SRWX^i\Pbgԁj */
#define	Sn_SR_CLOSED		0x00	/* N[Y */
#define	Sn_SR_INIT 			0x13	/* TCP[h I[v */
#define	Sn_SR_LISTEN		0x14	/* TCP LISTEN */
#define	Sn_SR_ESTABLISHED	0x17	/* TCP RlNV */
#define	Sn_SR_CLOSE_WAIT	0x1C	/* N[Y(Sn_SR_CLOSED) */
#define	Sn_SR_UDP			0x22	/* UDP[h I[v */
#define	Sn_SR_IPRAW			0x32	/* IPraw[h I[v */
#define	Sn_SR_MACRAW		0x42	/* MACraw[h I[v */
#define	Sn_SR_PPPoE			0x5F	/* PPPoE[h I[v */

/* Sn_SR̈ڍsߒŌ邱Ƃłe|Xe[^X */
#define	Sn_SR_SYNSENT		0x15	/* TCP SYNM */
#define	Sn_SR_SYNRECV		0x16	/* TCP SYNM */
#define	Sn_SR_FIN_WAIT		0x18	/* N[Y(Sn_SR_CLOSED) */
#define	Sn_SR_CLOSING		0x1A	/* N[Y(Sn_SR_CLOSED) */
#define	Sn_SR_TIME_WAIT		0x1B	/* N[Y(Sn_SR_CLOSED) */
#define	Sn_SR_LAST_ACK		0x1D	/* N[Y(Sn_SR_CLOSED) */
#define	Sn_SR_ARP			0x11	/* ARP-request` */
#define	Sn_SR_ARP2			0x21
#define	Sn_SR_ARP3			0x31

/* Sn_TOS	*/
#define	Sn_TOS_DEFAULT				0x00	/* ftHg	*/
#define	Sn_TOS_MIN_MONETARY_COST	0x01	/* RXgŏ	*/
#define	Sn_TOS_MAX_RELIABILITY		0x02	/* Mő	*/
#define	Sn_TOS_MAX_THROUGHPUT		0x04	/* X[vbgő	*/
#define	Sn_TOS_MIN_DELAY			0x08	/* xŏ			*/
#define	Sn_TOS_MAX_SECURITY			0x0f	/* őZLeB	*/

/* Mobt@TCY */
#define	S0_MEM_1K		(0<<0)
#define	S0_MEM_2K		(1<<0)
#define	S0_MEM_4K		(2<<0)
#define	S0_MEM_8K		(3<<0)

#define	S1_MEM_1K		(0<<2)
#define	S1_MEM_2K		(1<<2)
#define	S1_MEM_4K		(2<<2)
#define	S1_MEM_8K		(3<<2)

#define	S2_MEM_1K		(0<<4)
#define	S2_MEM_2K		(1<<4)
#define	S2_MEM_4K		(2<<4)
#define	S2_MEM_8K		(3<<4)

#define	S3_MEM_1K		(0<<6)
#define	S3_MEM_2K		(1<<6)
#define	S3_MEM_4K		(2<<6)
#define	S3_MEM_8K		(3<<6)


/* ---------- ʃWX^ ---------- */
void	clrNetInterrupt( byte data );					/* 荞ݐMNA	*/
byte	getNetInterrupt( void );						/* 荞ݐM擾	*/
void	setNetIntMask( byte mask );						/* 荞݃}XNݒ	*/
byte	getNetIntMask( void );							/* 荞݃}XN擾	*/
void	setRetryTime( word timeout );					/* đԐݒ	*/
word	getRetryTime( void );							/* đԎ擾	*/
void	setRetryCnt( byte retry );						/* đ񐔐ݒ	*/
byte	getRetryCnt( void );							/* đ񐔎擾	*/
void	setSrcIp( dword addr );							/* \[XIPAhXݒ	*/
dword	getSrcIp( void );								/* \[XIPAhX擾	*/
void	setNetmask( dword addr );						/* Tulbg}XNݒ	*/
dword	getNetmask( void );								/* Tulbg}XN擾	*/
void	setGateway( dword addr );						/* Q[gEFCAhXݒ	*/
dword	getGateway( void );								/* Q[gEFCAhX擾	*/
void	setMacAddr( byte *addr );						/* \[XMACAhXݒ	*/
void	getMacAddr( byte *addr );						/* \[XMACAhX擾	*/

word	getPatr( void );								/* PPPoE[h̔F؃^Cv擾	*/
dword	getUIp( void );									/* 񓞒BIPAhX擾 */
word	getUPort( void );								/* 񓞒B|[gԍ */

/* ---------- \Pbgʑ ---------- */
void	setSnMR( char sn, byte val );					/* \Pbg [hݒ	*/
byte	getSnMR( char sn );								/* \Pbg [h擾	*/
void	setSnCR( char sn, byte val );					/* \Pbg CRݒ	*/
byte	getSnCR( char sn );								/* \Pbg CR擾	*/
void	setSnIR( char sn, byte val );					/* \Pbg̊荞݃Xe[^Xݒ	*/
byte	getSnIR( char sn );								/* \Pbg̊荞݃Xe[^X擾	*/
byte	getSnSR( char sn );								/* \PbgXe[^X擾	*/

void	setSnSrcPort( char sn, word port );				/* \Pbg M|[gݒ	*/
word	getSnSrcPort( char sn );						/* \Pbg M|[g擾	*/
void	setSnDestMac( char sn, byte *addr );			/* \Pbg MMACAhXݒ	*/
void	getSnDestMac( char sn, byte *addr );			/* \Pbg MMACAhX擾	*/
void	setSnDestIp( char sn, dword addr );				/* \Pbg MIPAhXݒ	*/
dword	getSnDestIp( char sn );							/* \Pbg MIPAhX擾	*/
void	setSnDestPort( char sn, word port );			/* \Pbg M|[gݒ	*/
word	getSnDestPort( char sn );						/* \Pbg M|[g擾	*/
void	setSnMSS( char sn, word mss );					/* \Pbg MSSݒ	*/
word	getSnMSS( char sn );							/* \Pbg MSS擾	*/
void	setSnTOS( char sn, byte val );					/* \Pbg TOSݒ	*/
byte	getSnTOS( char sn );							/* \Pbg TOS擾	*/
void	setSnTTL( char sn, byte val );					/* \Pbg TTLݒ	*/
byte	getSnTTL( char sn );							/* \Pbg TTL擾	*/
void	setSnProto( char n, byte proto );				/* IPwb_̃vgRԍZbg(IP RAW[h)	*/
byte	getSnProto( char sn );							/* IPwb_̃vgRԍ擾(IP RAW[h)	*/
word	getSnTxFsr( char sn );							/* \Pbg̑M󂫃obt@TCY擾	*/
word	getSnTxRd( char sn );							/* \Pbg̑Mǂݎ|C^擾 	*/
void	setSnTxWr( char sn, word data );				/* \Pbg̑Mݒ	*/
word	getSnTxWr( char sn );							/* \Pbg̑M擾	*/
word	getSnRxRsr( char sn );							/* \Pbg̎Mς݃obt@TCY擾	*/
void	setSnRxRd( char sn, word pnt );					/* \Pbg̎Mǂݎ|C^ݒ	*/
word	getSnRxRd( char sn );							/* \Pbg̎Mǂݎ|C^擾	*/

void	send_data( char sn, byte *data, word len );		/* f[^𑗐M	*/
byte	*read_data( char sn, word srcAddr, byte *dstBuf, word len );	/* W5100̎Mobt@f[^o	*/

/* ----------  ---------- */
void 	resetNetwork(void);								/* W5100 S/WZbg	*/
void	InitNetConf( byte *mac, dword ipaddr, dword netmask, dword gateway );	/* lbg[N\	*/
void	InitSocket( byte tx_size, byte rx_size );		/* \Pbg[N	*/

#endif
